diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wave/test/ocb-test-suite.cc ns-3.33/src/wave/test/ocb-test-suite.cc
--- ns-3.32/src/wave/test/ocb-test-suite.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wave/test/ocb-test-suite.cc	2021-01-09 10:19:22.000000000 -0800
@@ -209,7 +209,7 @@
     {
       macassoc_time = Now ();
       macassoc_pos = GetCurrentPosition (1);
-      std::cout << "MacAssoc time = " << macassoc_time.GetNanoSeconds ()
+      std::cout << "MacAssoc time = " << macassoc_time.As (Time::NS)
                 << " position = " << macassoc_pos
                 << std::endl;
     }
@@ -224,7 +224,7 @@
     {
       phyrx_time = Now ();
       phyrx_pos = GetCurrentPosition (1);
-      std::cout << "PhyRxOk time = " << phyrx_time.GetNanoSeconds ()
+      std::cout << "PhyRxOk time = " << phyrx_time.As (Time::NS)
                 << " position = " << phyrx_pos
                 << std::endl;
     }
@@ -240,7 +240,7 @@
     {
       phytx_time = Now ();
       phytx_pos = GetCurrentPosition (1);
-      std::cout << "PhyTx data time = " << phytx_time.GetNanoSeconds ()
+      std::cout << "PhyTx data time = " << phytx_time.As (Time::NS)
                 << " position = " << phytx_pos
                 << std::endl;
     }
@@ -250,7 +250,7 @@
 OcbWifiMacTestCase::ConfigureApStaMode (Ptr<Node> static_node, Ptr<Node> mobile_node)
 {
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   wifiPhy.SetChannel (wifiChannel.Create ());
 
   Ssid ssid = Ssid ("wifi-default");
@@ -272,7 +272,7 @@
 OcbWifiMacTestCase::ConfigureAdhocMode (Ptr<Node> static_node, Ptr<Node> mobile_node)
 {
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   wifiPhy.SetChannel (wifiChannel.Create ());
 
   WifiMacHelper wifiMac;
@@ -291,7 +291,7 @@
 OcbWifiMacTestCase::ConfigureOcbMode (Ptr<Node> static_node, Ptr<Node> mobile_node)
 {
   YansWifiChannelHelper wifiChannel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   wifiPhy.SetChannel (wifiChannel.Create ());
 
   NqosWaveMacHelper wifi80211pMac = NqosWaveMacHelper::Default ();
@@ -431,7 +431,7 @@
   Simulator::Stop (Seconds (71.0));
   Simulator::Run ();
   Simulator::Destroy ();
-  NS_TEST_ASSERT_MSG_EQ (macassoc_time.GetNanoSeconds (), 0, "In Ocb mode, there is no associate state machine" );
+  NS_TEST_ASSERT_MSG_EQ (macassoc_time.GetNanoSeconds(), 0, "In Ocb mode, there is no associate state machine" );
   NS_TEST_ASSERT_MSG_LT (phytx_time, phyrx_time, "before mobile node receives frames from far static node, it can send data packet directly" );
   NS_TEST_ASSERT_MSG_EQ (macassoc_pos.x, 0.0, "");
   NS_TEST_ASSERT_MSG_GT ((phytx_pos.x - phyrx_pos.x), 0.0, "");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/bindings/callbacks_list.py ns-3.33/src/wifi/bindings/callbacks_list.py
--- ns-3.32/src/wifi/bindings/callbacks_list.py	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/bindings/callbacks_list.py	2021-01-09 10:19:22.000000000 -0800
@@ -27,11 +27,12 @@
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::WifiMode', 'ns3::WifiPreamble', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiMode', 'ns3::WifiPreamble', 'unsigned char', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::WifiPsdu>', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'std::unordered_map<unsigned short, ns3::Ptr<const ns3::WifiPsdu>, std::hash<unsigned short>, std::equal_to<unsigned short>, std::allocator<std::pair<const unsigned short, ns3::Ptr<const ns3::WifiPsdu> > > >', 'ns3::WifiTxVector', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'std::map<std::pair<unsigned int, unsigned int>, double, std::less<std::pair<unsigned int, unsigned int> >, std::allocator<std::pair<const std::pair<unsigned int, unsigned int>, double> > >', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::WifiTxVector', 'ns3::Time', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::Packet>', 'ns3::WifiPhyRxfailureReason', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
-    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'ns3::SignalNoiseDbm', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
+    ['void', 'ns3::Ptr<const ns3::Packet>', 'unsigned short', 'ns3::WifiTxVector', 'ns3::MpduInfo', 'unsigned short', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::HePreambleParameters', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::MobilityModel>', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
     ['void', 'ns3::Ptr<const ns3::SpectrumPhy>', 'ns3::Ptr<const ns3::SpectrumPhy>', 'double', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty', 'ns3::empty'],
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/doc/Makefile ns-3.33/src/wifi/doc/Makefile
--- ns-3.32/src/wifi/doc/Makefile	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/doc/Makefile	2021-01-09 10:19:22.000000000 -0800
@@ -23,7 +23,9 @@
         $(FIGURES)/nist-frame-success-rate-ac.eps \
         $(FIGURES)/nist-frame-success-rate-ax.eps \
         $(FIGURES)/wifi-11a-p-1500-adhoc-r-54-min-5-max-50-step-5-throughput.eps \
-        $(FIGURES)/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps
+        $(FIGURES)/wifi-11g-p-1500-infrastructure-r-6-min-5-max-50-step-5-throughput.eps \
+        $(FIGURES)/default-table-based-error-model-validation.eps \
+        $(FIGURES)/error-models-comparison.eps
 
 # rescale pdf figures as necessary
 $(FIGURES)/snir.pdf_width = 3in
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/examples/wifi-bianchi.cc ns-3.33/src/wifi/examples/wifi-bianchi.cc
--- ns-3.32/src/wifi/examples/wifi-bianchi.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/examples/wifi-bianchi.cc	2021-01-09 10:19:22.000000000 -0800
@@ -428,7 +428,7 @@
 }
 
 void
-TracePacketReception (std::string context, Ptr<const Packet> packet, uint16_t channelFreqMhz, WifiTxVector txVector, MpduInfo aMpdu, SignalNoiseDbm signalNoise)
+TracePacketReception (std::string context, Ptr<const Packet> packet, uint16_t channelFreqMhz, WifiTxVector txVector, MpduInfo aMpdu, SignalNoiseDbm signalNoise, uint16_t staId)
 {
   WifiMacHeader hdr;
   packet->PeekHeader (hdr);
@@ -480,7 +480,7 @@
 }
 
 void
-PhyRxTrace (std::string context, Ptr<const Packet> p)
+PhyRxTrace (std::string context, Ptr<const Packet> p, RxPowerWattPerChannelBand power)
 {
   NS_LOG_INFO ("PHY-RX-START time=" << Simulator::Now () << " node=" << ContextToNodeId (context) << " size=" << p->GetSize ());
 }
@@ -712,6 +712,7 @@
     }
 
   YansWifiPhyHelper phy = wifiPhy;
+  phy.SetErrorRateModel ("ns3::NistErrorRateModel");
   phy.SetChannel (wifiChannel.Create ());
   phy.SetPcapDataLinkType (WifiPhyHelper::DLT_IEEE802_11_RADIO);
 
@@ -1001,7 +1002,7 @@
       NS_FATAL_ERROR ("Unsupported standard: " << standard);
     }
 
-  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
   YansWifiChannelHelper wifiChannel;
   wifiChannel.SetPropagationDelay ("ns3::ConstantSpeedPropagationDelayModel");
   wifiChannel.AddPropagationLoss ("ns3::LogDistancePropagationLossModel");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/examples/wifi-manager-example.cc ns-3.33/src/wifi/examples/wifi-manager-example.cc
--- ns-3.32/src/wifi/examples/wifi-manager-example.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/examples/wifi-manager-example.cc	2021-01-09 10:19:22.000000000 -0800
@@ -334,7 +334,7 @@
 
   WifiHelper wifi;
   wifi.SetStandard (serverSelectedStandard.m_standard);
-  YansWifiPhyHelper wifiPhy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper wifiPhy;
 
   Ptr<YansWifiChannel> wifiChannel = CreateObject<YansWifiChannel> ();
   Ptr<ConstantSpeedPropagationDelayModel> delayModel = CreateObject<ConstantSpeedPropagationDelayModel> ();
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/examples/wifi-phy-configuration.cc ns-3.33/src/wifi/examples/wifi-phy-configuration.cc
--- ns-3.32/src/wifi/examples/wifi-phy-configuration.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/examples/wifi-phy-configuration.cc	2021-01-09 10:19:22.000000000 -0800
@@ -73,7 +73,7 @@
   wifiApNode.Create (1);
 
   YansWifiChannelHelper channel = YansWifiChannelHelper::Default ();
-  YansWifiPhyHelper phy = YansWifiPhyHelper::Default ();
+  YansWifiPhyHelper phy;
   phy.SetChannel (channel.Create ());
   WifiHelper wifi;
   wifi.SetRemoteStationManager ("ns3::IdealWifiManager");
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/examples/wifi-trans-example.cc ns-3.33/src/wifi/examples/wifi-trans-example.cc
--- ns-3.32/src/wifi/examples/wifi-trans-example.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/examples/wifi-trans-example.cc	2021-01-09 10:19:22.000000000 -0800
@@ -217,7 +217,7 @@
 
   /* Wi-Fi transmitter setup */
 
-  SpectrumWifiPhyHelper spectrumPhy = SpectrumWifiPhyHelper::Default ();
+  SpectrumWifiPhyHelper spectrumPhy;
   spectrumPhy.SetChannel (channel);
   spectrumPhy.SetErrorRateModel ("ns3::NistErrorRateModel");
   spectrumPhy.Set ("Frequency", UintegerValue (freq));
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/helper/spectrum-wifi-helper.cc ns-3.33/src/wifi/helper/spectrum-wifi-helper.cc
--- ns-3.32/src/wifi/helper/spectrum-wifi-helper.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/helper/spectrum-wifi-helper.cc	2021-01-09 10:19:22.000000000 -0800
@@ -36,14 +36,7 @@
   : m_channel (0)
 {
   m_phy.SetTypeId ("ns3::SpectrumWifiPhy");
-}
-
-SpectrumWifiPhyHelper
-SpectrumWifiPhyHelper::Default (void)
-{
-  SpectrumWifiPhyHelper helper;
-  helper.SetErrorRateModel ("ns3::NistErrorRateModel");
-  return helper;
+  SetErrorRateModel ("ns3::TableBasedErrorRateModel");
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/helper/spectrum-wifi-helper.h ns-3.33/src/wifi/helper/spectrum-wifi-helper.h
--- ns-3.32/src/wifi/helper/spectrum-wifi-helper.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/helper/spectrum-wifi-helper.h	2021-01-09 10:19:22.000000000 -0800
@@ -38,18 +38,11 @@
 {
 public:
   /**
-   * Create a PHY helper without any parameter set. The user must set
-   * them all to be able to call Install later.
+   * Create a PHY helper.
    */
   SpectrumWifiPhyHelper ();
 
   /**
-   * Create a PHY helper in a default working state.
-   * \returns a default SpectrumWifPhyHelper
-   */
-  static SpectrumWifiPhyHelper Default (void);
-
-  /**
    * \param channel the channel to associate to this helper
    *
    * Every PHY created by a call to Install is associated to this channel.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/helper/wifi-helper.cc ns-3.33/src/wifi/helper/wifi-helper.cc
--- ns-3.32/src/wifi/helper/wifi-helper.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/helper/wifi-helper.cc	2021-01-09 10:19:22.000000000 -0800
@@ -226,7 +226,8 @@
   Ptr<const Packet>    packet,
   uint16_t             channelFreqMhz,
   WifiTxVector         txVector,
-  MpduInfo             aMpdu)
+  MpduInfo             aMpdu,
+  uint16_t             staId)
 {
   uint32_t dlt = file->GetDataLinkType ();
   switch (dlt)
@@ -243,7 +244,7 @@
       {
         Ptr<Packet> p = packet->Copy ();
         RadiotapHeader header;
-        GetRadiotapHeader (header, p, channelFreqMhz, txVector, aMpdu);
+        GetRadiotapHeader (header, p, channelFreqMhz, txVector, aMpdu, staId);
         p->AddHeader (header);
         file->Write (Simulator::Now (), p);
         return;
@@ -260,7 +261,8 @@
   uint16_t              channelFreqMhz,
   WifiTxVector          txVector,
   MpduInfo              aMpdu,
-  SignalNoiseDbm        signalNoise)
+  SignalNoiseDbm        signalNoise,
+  uint16_t              staId)
 {
   uint32_t dlt = file->GetDataLinkType ();
   switch (dlt)
@@ -277,7 +279,7 @@
       {
         Ptr<Packet> p = packet->Copy ();
         RadiotapHeader header;
-        GetRadiotapHeader (header, p, channelFreqMhz, txVector, aMpdu, signalNoise);
+        GetRadiotapHeader (header, p, channelFreqMhz, txVector, aMpdu, staId, signalNoise);
         p->AddHeader (header);
         file->Write (Simulator::Now (), p);
         return;
@@ -294,11 +296,12 @@
   uint16_t             channelFreqMhz,
   WifiTxVector         txVector,
   MpduInfo             aMpdu,
+  uint16_t             staId,
   SignalNoiseDbm       signalNoise)
 {
   header.SetAntennaSignalPower (signalNoise.signal);
   header.SetAntennaNoisePower (signalNoise.noise);
-  GetRadiotapHeader (header, packet, channelFreqMhz, txVector, aMpdu);
+  GetRadiotapHeader (header, packet, channelFreqMhz, txVector, aMpdu, staId);
 }
 
 void
@@ -307,7 +310,8 @@
   Ptr<Packet>          packet,
   uint16_t             channelFreqMhz,
   WifiTxVector         txVector,
-  MpduInfo             aMpdu)
+  MpduInfo             aMpdu,
+  uint16_t             staId)
 {
   WifiPreamble preamble = txVector.GetPreambleType ();
 
@@ -330,11 +334,11 @@
   header.SetFrameFlags (frameFlags);
 
   uint64_t rate = 0;
-  if (txVector.GetMode ().GetModulationClass () != WIFI_MOD_CLASS_HT
-      && txVector.GetMode ().GetModulationClass () != WIFI_MOD_CLASS_VHT
-      && txVector.GetMode ().GetModulationClass () != WIFI_MOD_CLASS_HE)
+  if (txVector.GetMode (staId).GetModulationClass () != WIFI_MOD_CLASS_HT
+      && txVector.GetMode (staId).GetModulationClass () != WIFI_MOD_CLASS_VHT
+      && txVector.GetMode (staId).GetModulationClass () != WIFI_MOD_CLASS_HE)
     {
-      rate = txVector.GetMode ().GetDataRate (txVector.GetChannelWidth (), txVector.GetGuardInterval (), 1) * txVector.GetNss () / 500000;
+      rate = txVector.GetMode (staId).GetDataRate (txVector.GetChannelWidth (), txVector.GetGuardInterval (), 1) * txVector.GetNss (staId) / 500000;
       header.SetRate (static_cast<uint8_t> (rate));
     }
 
@@ -363,7 +367,7 @@
 
   header.SetChannelFrequencyAndFlags (channelFreqMhz, channelFlags);
 
-  if (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HT)
+  if (txVector.GetMode (staId).GetModulationClass () == WIFI_MOD_CLASS_HT)
     {
       uint8_t mcsKnown = RadiotapHeader::MCS_KNOWN_NONE;
       uint8_t mcsFlags = RadiotapHeader::MCS_FLAGS_NONE;
@@ -406,7 +410,7 @@
           mcsFlags |= RadiotapHeader::MCS_FLAGS_STBC_STREAMS;
         }
 
-      header.SetMcsFields (mcsKnown, mcsFlags, txVector.GetMode ().GetMcsValue ());
+      header.SetMcsFields (mcsKnown, mcsFlags, txVector.GetMode (staId).GetMcsValue ());
     }
 
   if (txVector.IsAggregation ())
@@ -426,7 +430,7 @@
       header.SetAmpduStatus (aMpdu.mpduRefNumber, ampduStatusFlags, 1 /*CRC*/);
     }
 
-  if (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_VHT)
+  if (txVector.GetMode (staId).GetModulationClass () == WIFI_MOD_CLASS_VHT)
     {
       uint16_t vhtKnown = RadiotapHeader::VHT_KNOWN_NONE;
       uint8_t vhtFlags = RadiotapHeader::VHT_FLAGS_NONE;
@@ -466,15 +470,15 @@
         }
 
       //only SU PPDUs are currently supported
-      vhtMcsNss[0] |= (txVector.GetNss () & 0x0f);
-      vhtMcsNss[0] |= ((txVector.GetMode ().GetMcsValue () << 4) & 0xf0);
+      vhtMcsNss[0] |= (txVector.GetNss (staId) & 0x0f);
+      vhtMcsNss[0] |= ((txVector.GetMode (staId).GetMcsValue () << 4) & 0xf0);
 
       header.SetVhtFields (vhtKnown, vhtFlags, vhtBandwidth, vhtMcsNss, vhtCoding, vhtGroupId, vhtPartialAid);
     }
 
-  if (txVector.GetMode ().GetModulationClass () == WIFI_MOD_CLASS_HE)
+  if (txVector.GetMode (staId).GetModulationClass () == WIFI_MOD_CLASS_HE)
     {
-      uint16_t data1 = RadiotapHeader::HE_DATA1_STBC_KNOWN | RadiotapHeader::HE_DATA1_DATA_MCS_KNOWN;
+      uint16_t data1 = RadiotapHeader::HE_DATA1_BSS_COLOR_KNOWN | RadiotapHeader::HE_DATA1_DATA_MCS_KNOWN | RadiotapHeader::HE_DATA1_BW_RU_ALLOC_KNOWN;
       if (preamble == WIFI_PREAMBLE_HE_ER_SU)
         {
           data1 |= RadiotapHeader::HE_DATA1_FORMAT_EXT_SU;
@@ -482,22 +486,64 @@
       else if (preamble == WIFI_PREAMBLE_HE_MU)
         {
           data1 |= RadiotapHeader::HE_DATA1_FORMAT_MU;
+          data1 |= RadiotapHeader::HE_DATA1_SPTL_REUSE2_KNOWN;
         }
       else if (preamble == WIFI_PREAMBLE_HE_TB)
         {
           data1 |= RadiotapHeader::HE_DATA1_FORMAT_TRIG;
         }
 
-      uint16_t data2 = RadiotapHeader::HE_DATA2_NUM_LTF_SYMS_KNOWN | RadiotapHeader::HE_DATA2_GI_KNOWN;
+      uint16_t data2 = RadiotapHeader::HE_DATA2_GI_KNOWN;
+      if (preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB)
+        {
+          data2 |= RadiotapHeader::HE_DATA2_RU_OFFSET_KNOWN;
+          //HeRu indices start at 1 whereas RadioTap starts at 0
+          data2 |= (((txVector.GetHeMuUserInfo (staId).ru.index - 1) << 8) & 0x3f00);
+          data2 |= (((!txVector.GetHeMuUserInfo (staId).ru.primary80MHz) << 15) & 0x8000);
+        }
 
       uint16_t data3 = 0;
-      if (txVector.IsStbc ())
+      data3 |= (txVector.GetBssColor () & 0x003f);
+      data3 |= ((txVector.GetMode (staId).GetMcsValue () << 8) & 0x0f00);
+
+      uint16_t data4 = 0;
+      if (preamble == WIFI_PREAMBLE_HE_MU)
         {
-          data3 |= RadiotapHeader::HE_DATA3_STBC;
+          data4 |= ((staId << 4) & 0x7ff0);
         }
 
       uint16_t data5 = 0;
-      if (txVector.GetChannelWidth () == 40)
+      if (preamble == WIFI_PREAMBLE_HE_MU || preamble == WIFI_PREAMBLE_HE_TB)
+        {
+          HeRu::RuType ruType = txVector.GetHeMuUserInfo (staId).ru.ruType;
+          switch (ruType)
+            {
+            case HeRu::RU_26_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_26T;
+              break;
+            case HeRu::RU_52_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_52T;
+              break;
+            case HeRu::RU_106_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_106T;
+              break;
+            case HeRu::RU_242_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_242T;
+              break;
+            case HeRu::RU_484_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_484T;
+              break;
+            case HeRu::RU_996_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_996T;
+              break;
+            case HeRu::RU_2x996_TONE:
+              data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_2x996T;
+              break;
+            default:
+              NS_ABORT_MSG ("Unexpected RU type");
+            }
+        }
+      else if (txVector.GetChannelWidth () == 40)
         {
           data5 |= RadiotapHeader::HE_DATA5_DATA_BW_RU_ALLOC_40MHZ;
         }
@@ -518,7 +564,15 @@
           data5 |= RadiotapHeader::HE_DATA5_GI_3_2;
         }
 
-      header.SetHeFields (data1, data2, data3, data5);
+      header.SetHeFields (data1, data2, data3, data4, data5, 0);
+    }
+  
+  if (preamble == WIFI_PREAMBLE_HE_MU)
+    {
+      //TODO: fill in fields (everything is set to 0 so far)
+      std::array<uint8_t, 4> ruChannel1, ruChannel2;
+      header.SetHeMuFields (0, 0, ruChannel1, ruChannel2);
+      header.SetHeMuPerUserFields (0, 0, 0, 0);
     }
 }
 
@@ -937,12 +991,14 @@
   LogComponentEnable ("BlockAckCache", LOG_LEVEL_ALL);
   LogComponentEnable ("BlockAckManager", LOG_LEVEL_ALL);
   LogComponentEnable ("CaraWifiManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("ChannelAccessManager", LOG_LEVEL_ALL);
   LogComponentEnable ("ConstantObssPdAlgorithm", LOG_LEVEL_ALL);
   LogComponentEnable ("ConstantRateWifiManager", LOG_LEVEL_ALL);
-  LogComponentEnable ("Txop", LOG_LEVEL_ALL);
+  LogComponentEnable ("ConstantWifiAckPolicySelector", LOG_LEVEL_ALL);
   LogComponentEnable ("ChannelAccessManager", LOG_LEVEL_ALL);
   LogComponentEnable ("DsssErrorRateModel", LOG_LEVEL_ALL);
-  LogComponentEnable ("QosTxop", LOG_LEVEL_ALL);
+  LogComponentEnable ("HeConfiguration", LOG_LEVEL_ALL);
+  LogComponentEnable ("HtConfiguration", LOG_LEVEL_ALL);
   LogComponentEnable ("IdealWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("InfrastructureWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("InterferenceHelper", LOG_LEVEL_ALL);
@@ -956,7 +1012,9 @@
   LogComponentEnable ("NistErrorRateModel", LOG_LEVEL_ALL);
   LogComponentEnable ("ObssPdAlgorithm", LOG_LEVEL_ALL);
   LogComponentEnable ("OnoeWifiManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("OriginatorBlockAckAgreement", LOG_LEVEL_ALL);
   LogComponentEnable ("ParfWifiManager", LOG_LEVEL_ALL);
+  LogComponentEnable ("QosTxop", LOG_LEVEL_ALL);
   LogComponentEnable ("RegularWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("RraaWifiManager", LOG_LEVEL_ALL);
   LogComponentEnable ("RrpaaWifiManager", LOG_LEVEL_ALL);
@@ -964,8 +1022,13 @@
   LogComponentEnable ("SpectrumWifiPhy", LOG_LEVEL_ALL);
   LogComponentEnable ("StaWifiMac", LOG_LEVEL_ALL);
   LogComponentEnable ("SupportedRates", LOG_LEVEL_ALL);
+  LogComponentEnable ("TableBasedErrorRateModel", LOG_LEVEL_ALL);
   LogComponentEnable ("ThresholdPreambleDetectionModel", LOG_LEVEL_ALL);
+  LogComponentEnable ("Txop", LOG_LEVEL_ALL);
+  LogComponentEnable ("VhtConfiguration", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiAckPolicySelector", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiMac", LOG_LEVEL_ALL);
+  LogComponentEnable ("WifiMacQueue", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiMacQueueItem", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiNetDevice", LOG_LEVEL_ALL);
   LogComponentEnable ("WifiPhyStateHelper", LOG_LEVEL_ALL);
@@ -980,6 +1043,9 @@
   LogComponentEnable ("YansErrorRateModel", LOG_LEVEL_ALL);
   LogComponentEnable ("YansWifiChannel", LOG_LEVEL_ALL);
   LogComponentEnable ("YansWifiPhy", LOG_LEVEL_ALL);
+
+  //From Spectrum
+  LogComponentEnable ("WifiSpectrumValueHelper", LOG_LEVEL_ALL);
 }
 
 int64_t
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/helper/wifi-helper.h ns-3.33/src/wifi/helper/wifi-helper.h
--- ns-3.32/src/wifi/helper/wifi-helper.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/helper/wifi-helper.h	2021-01-09 10:19:22.000000000 -0800
@@ -208,6 +208,7 @@
    * \param channelFreqMhz the channel frequency
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
+   * \param staId the STA-ID (only used for MU)
    *
    * Handle TX pcap.
    */
@@ -215,7 +216,8 @@
                                 Ptr<const Packet> packet,
                                 uint16_t channelFreqMhz,
                                 WifiTxVector txVector,
-                                MpduInfo aMpdu);
+                                MpduInfo aMpdu,
+                                uint16_t staId = SU_STA_ID);
   /**
    * \param file the pcap file wrapper
    * \param packet the packet
@@ -223,6 +225,7 @@
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
    * \param signalNoise the RX signal and noise information
+   * \param staId the STA-ID (only used for MU)
    *
    * Handle RX pcap.
    */
@@ -231,7 +234,8 @@
                                 uint16_t channelFreqMhz,
                                 WifiTxVector txVector,
                                 MpduInfo aMpdu,
-                                SignalNoiseDbm signalNoise);
+                                SignalNoiseDbm signalNoise,
+                                uint16_t staId = SU_STA_ID);
 
   ObjectFactory m_phy; ///< PHY object
   ObjectFactory m_errorRateModel; ///< error rate model
@@ -248,12 +252,14 @@
    * \param channelFreqMhz the channel frequency
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
+   * \param staId the STA-ID
    */
   static void GetRadiotapHeader (RadiotapHeader &header,
                                  Ptr<Packet> packet,
                                  uint16_t channelFreqMhz,
                                  WifiTxVector txVector,
-                                 MpduInfo aMpdu);
+                                 MpduInfo aMpdu,
+                                 uint16_t staId);
 
   /**
    * Get the Radiotap header for a received packet.
@@ -263,6 +269,7 @@
    * \param channelFreqMhz the channel frequency
    * \param txVector the TXVECTOR
    * \param aMpdu the A-MPDU information
+   * \param staId the STA-ID
    * \param signalNoise the rx signal and noise information
    */
   static void GetRadiotapHeader (RadiotapHeader &header,
@@ -270,6 +277,7 @@
                                  uint16_t channelFreqMhz,
                                  WifiTxVector txVector,
                                  MpduInfo aMpdu,
+                                 uint16_t staId,
                                  SignalNoiseDbm signalNoise);
 
   /**
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/helper/yans-wifi-helper.cc ns-3.33/src/wifi/helper/yans-wifi-helper.cc
--- ns-3.32/src/wifi/helper/yans-wifi-helper.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/helper/yans-wifi-helper.cc	2021-01-09 10:19:22.000000000 -0800
@@ -127,14 +127,7 @@
   : m_channel (0)
 {
   m_phy.SetTypeId ("ns3::YansWifiPhy");
-}
-
-YansWifiPhyHelper
-YansWifiPhyHelper::Default (void)
-{
-  YansWifiPhyHelper helper;
-  helper.SetErrorRateModel ("ns3::NistErrorRateModel");
-  return helper;
+  SetErrorRateModel ("ns3::TableBasedErrorRateModel");
 }
 
 void
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/helper/yans-wifi-helper.h ns-3.33/src/wifi/helper/yans-wifi-helper.h
--- ns-3.32/src/wifi/helper/yans-wifi-helper.h	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/helper/yans-wifi-helper.h	2021-01-09 10:19:22.000000000 -0800
@@ -161,18 +161,11 @@
 {
 public:
   /**
-   * Create a PHY helper without any parameter set. The user must set
-   * them all to be able to call Install later.
+   * Create a PHY helper.
    */
   YansWifiPhyHelper ();
 
   /**
-   * Create a PHY helper in a default working state.
-   * \returns a default YansWifiPhyHelper
-   */
-  static YansWifiPhyHelper Default (void);
-
-  /**
    * \param channel the channel to associate to this helper
    *
    * Every PHY created by a call to Install is associated to this channel.
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/aarfcd-wifi-manager.cc ns-3.33/src/wifi/model/aarfcd-wifi-manager.cc
--- ns-3.32/src/wifi/model/aarfcd-wifi-manager.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/aarfcd-wifi-manager.cc	2021-01-09 10:19:22.000000000 -0800
@@ -330,7 +330,7 @@
       NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
       m_currentRate = mode.GetDataRate (channelWidth);
     }
-  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station), false);
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 WifiTxVector
@@ -355,7 +355,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station), false);
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station));
   return rtsTxVector;
 }
 
diff -Naur -x '*.dia' -x '*.pcap' -x '*.png' ns-3.32/src/wifi/model/aarf-wifi-manager.cc ns-3.33/src/wifi/model/aarf-wifi-manager.cc
--- ns-3.32/src/wifi/model/aarf-wifi-manager.cc	2020-10-06 15:35:43.000000000 -0700
+++ ns-3.33/src/wifi/model/aarf-wifi-manager.cc	2021-01-09 10:19:22.000000000 -0800
@@ -262,7 +262,7 @@
       NS_LOG_DEBUG ("New datarate: " << mode.GetDataRate (channelWidth));
       m_currentRate = mode.GetDataRate (channelWidth);
     }
-  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station), false);
+  return WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station));
 }
 
 WifiTxVector
@@ -287,7 +287,7 @@
     {
       mode = GetNonErpSupported (station, 0);
     }
-  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station), false);
+  rtsTxVector = WifiTxVector (mode, GetDefaultTxPowerLevel (), GetPreambleForTransmission (mode.GetModulationClass (), GetShortPreambleEnabled (), UseGreenfieldForDestination (GetAddress (station))), 800, 1, 1, 0, channelWidth, GetAggregation (station));
   return rtsTxVector;
 }
 
